package com.ab.ab3dcamera;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.ab.ab3dcamera", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "com.ab.ab3dcamera", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public static class _item3d{
boolean IsInitialized;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper bmp;
int Top;
int Left;
int Width;
int Height;
public void Initialize() {
IsInitialized = true;
bmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
Top = 0;
Left = 0;
Width = 0;
Height = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.collections.List _items = null;
public static float _halfheight = 0f;
public static float _scale_down_factor = 0f;
public static int _degrees_per_screen = 0;
public static int _ambient_light = 0;
public static int _diffuse_light = 0;
public static float _specular_light = 0f;
public static float _shininess = 0f;
public static int _max_intensity = 0;
public static int _currentrotation = 0;
public static int _currenttop = 0;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _mycanvas = null;
public static int _screentop = 0;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public com.AB.ABExtDrawing.ABExtDrawing _exdraw = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABCamera _mcamera = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABMatrix _mmatrix = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _mpaint = null;
public static double _pi = 0;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _clearrect = null;
public static int _curry = 0;
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _backbmp = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _backbmp2 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _backbmp3 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _conbmp = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _conbmp2 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _conbmp3 = null;
int _i = 0;
int _random = 0;
 //BA.debugLineNum = 47;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 48;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 50;BA.debugLine="MyCanvas.Initialize(Panel1)";
mostCurrent._mycanvas.Initialize((android.view.View)(mostCurrent._panel1.getObject()));
 //BA.debugLineNum = 52;BA.debugLine="HalfHeight = Activity.Height / 2";
_halfheight = (float)(mostCurrent._activity.getHeight()/(double)2);
 //BA.debugLineNum = 54;BA.debugLine="Dim backbmp As Bitmap";
_backbmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 55;BA.debugLine="backbmp.Initialize(File.DirAssets, \"background.png\")";
_backbmp.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"background.png");
 //BA.debugLineNum = 56;BA.debugLine="Dim backbmp2 As Bitmap";
_backbmp2 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 57;BA.debugLine="backbmp2.Initialize(File.DirAssets, \"background2.png\")";
_backbmp2.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"background2.png");
 //BA.debugLineNum = 58;BA.debugLine="Dim backbmp3 As Bitmap";
_backbmp3 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 59;BA.debugLine="backbmp3.Initialize(File.DirAssets, \"background3.png\")";
_backbmp3.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"background3.png");
 //BA.debugLineNum = 61;BA.debugLine="Dim conbmp As Bitmap";
_conbmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 62;BA.debugLine="conbmp.Initialize(File.DirAssets, \"contact_image.png\")";
_conbmp.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"contact_image.png");
 //BA.debugLineNum = 63;BA.debugLine="Dim conbmp2 As Bitmap";
_conbmp2 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 64;BA.debugLine="conbmp2.Initialize(File.DirAssets, \"contact_image2.png\")";
_conbmp2.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"contact_image2.png");
 //BA.debugLineNum = 65;BA.debugLine="Dim conbmp3 As Bitmap";
_conbmp3 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 66;BA.debugLine="conbmp3.Initialize(File.DirAssets, \"contact_image3.png\")";
_conbmp3.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"contact_image3.png");
 //BA.debugLineNum = 68;BA.debugLine="items.Initialize";
mostCurrent._items.Initialize();
 //BA.debugLineNum = 69;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 70;BA.debugLine="Dim random As Int";
_random = 0;
 //BA.debugLineNum = 71;BA.debugLine="For i = 0 To 19";
{
final double step54 = 1;
final double limit54 = (int)(19);
for (_i = (int)(0); (step54 > 0 && _i <= limit54) || (step54 < 0 && _i >= limit54); _i += step54) {
 //BA.debugLineNum = 72;BA.debugLine="random = Rnd(0,3)";
_random = anywheresoftware.b4a.keywords.Common.Rnd((int)(0),(int)(3));
 //BA.debugLineNum = 73;BA.debugLine="If random = 0 Then";
if (_random==0) { 
 //BA.debugLineNum = 74;BA.debugLine="items.Add(CreateNewItem(backbmp, conbmp, \"Colleague \" & i, \"Name of colleague \" & i, 25, i*175, Activity.Width - 50, 120))";
mostCurrent._items.Add((Object)(_createnewitem(_backbmp,_conbmp,"Colleague "+BA.NumberToString(_i),"Name of colleague "+BA.NumberToString(_i),(int)(25),(int)(_i*175),(int)(mostCurrent._activity.getWidth()-50),(int)(120))));
 }else {
 //BA.debugLineNum = 76;BA.debugLine="If random = 1 Then";
if (_random==1) { 
 //BA.debugLineNum = 77;BA.debugLine="items.Add(CreateNewItem(backbmp2, conbmp2, \"Friend \" & i, \"Name of friend \" & i, 25, i*175, Activity.Width - 50, 120))";
mostCurrent._items.Add((Object)(_createnewitem(_backbmp2,_conbmp2,"Friend "+BA.NumberToString(_i),"Name of friend "+BA.NumberToString(_i),(int)(25),(int)(_i*175),(int)(mostCurrent._activity.getWidth()-50),(int)(120))));
 }else {
 //BA.debugLineNum = 79;BA.debugLine="items.Add(CreateNewItem(backbmp3, conbmp3, \"Client \" & i, \"Name of the client \" & i, 25, i*175, Activity.Width - 50, 120))";
mostCurrent._items.Add((Object)(_createnewitem(_backbmp3,_conbmp3,"Client "+BA.NumberToString(_i),"Name of the client "+BA.NumberToString(_i),(int)(25),(int)(_i*175),(int)(mostCurrent._activity.getWidth()-50),(int)(120))));
 };
 };
 }
};
 //BA.debugLineNum = 84;BA.debugLine="CurrentRotation = -(DEGREES_PER_SCREEN * ScreenTop) / Activity.Height";
_currentrotation = (int)(-(_degrees_per_screen*_screentop)/(double)mostCurrent._activity.getHeight());
 //BA.debugLineNum = 86;BA.debugLine="ClearRect.Initialize(0,0,Activity.Width, Activity.Height)";
mostCurrent._clearrect.Initialize((int)(0),(int)(0),mostCurrent._activity.getWidth(),mostCurrent._activity.getHeight());
 //BA.debugLineNum = 88;BA.debugLine="mCamera.Initialize";
mostCurrent._mcamera.Initialize();
 //BA.debugLineNum = 89;BA.debugLine="mMatrix.Initialize";
mostCurrent._mmatrix.Initialize();
 //BA.debugLineNum = 90;BA.debugLine="mPaint.Initialize";
mostCurrent._mpaint.Initialize();
 //BA.debugLineNum = 91;BA.debugLine="mPaint.SetAntiAlias(True)";
mostCurrent._mpaint.SetAntiAlias(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 92;BA.debugLine="mPaint.SetFilterBitmap(True)";
mostCurrent._mpaint.SetFilterBitmap(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 94;BA.debugLine="DrawMe";
_drawme();
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 101;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 97;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static main._item3d  _createnewitem(anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _background,anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _icon,String _subj,String _desc,int _left,int _top,int _width,int _height) throws Exception{
main._item3d _item = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper _c = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _dstr = null;
 //BA.debugLineNum = 105;BA.debugLine="Sub CreateNewItem(Background As Bitmap, icon As Bitmap, Subj As String, desc As String, Left As Int, Top As Int, Width As Int, Height As Int) As item3D";
 //BA.debugLineNum = 106;BA.debugLine="Dim item As item3D";
_item = new main._item3d();
 //BA.debugLineNum = 107;BA.debugLine="Dim c As Canvas";
_c = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 108;BA.debugLine="item.Initialize";
_item.Initialize();
 //BA.debugLineNum = 109;BA.debugLine="item.bmp.InitializeMutable(Width, Height)";
_item.bmp.InitializeMutable(_width,_height);
 //BA.debugLineNum = 111;BA.debugLine="c.Initialize2(item.bmp)";
_c.Initialize2((android.graphics.Bitmap)(_item.bmp.getObject()));
 //BA.debugLineNum = 114;BA.debugLine="Dim dstR As Rect";
_dstr = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 115;BA.debugLine="dstR.Initialize(0,0,Width,Height)";
_dstr.Initialize((int)(0),(int)(0),_width,_height);
 //BA.debugLineNum = 116;BA.debugLine="c.DrawBitmap(Background,Null, dstR)";
_c.DrawBitmap((android.graphics.Bitmap)(_background.getObject()),(android.graphics.Rect)(anywheresoftware.b4a.keywords.Common.Null),(android.graphics.Rect)(_dstr.getObject()));
 //BA.debugLineNum = 119;BA.debugLine="dstR.Initialize(15,15, icon.Width, icon.Height)";
_dstr.Initialize((int)(15),(int)(15),_icon.getWidth(),_icon.getHeight());
 //BA.debugLineNum = 120;BA.debugLine="c.DrawBitmap(icon, Null, dstR)";
_c.DrawBitmap((android.graphics.Bitmap)(_icon.getObject()),(android.graphics.Rect)(anywheresoftware.b4a.keywords.Common.Null),(android.graphics.Rect)(_dstr.getObject()));
 //BA.debugLineNum = 122;BA.debugLine="c.DrawText(Subj, 100, 30,Typeface.DEFAULT_BOLD,16, Colors.White,\"LEFT\")";
_c.DrawText(mostCurrent.activityBA,_subj,(float)(100),(float)(30),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,(float)(16),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 123;BA.debugLine="c.DrawText(desc, 100, 60, Typeface.DEFAULT,16, Colors.White,\"LEFT\")";
_c.DrawText(mostCurrent.activityBA,_desc,(float)(100),(float)(60),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(16),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 125;BA.debugLine="item.Top = Top";
_item.Top = _top;
 //BA.debugLineNum = 126;BA.debugLine="item.Left = Left";
_item.Left = _left;
 //BA.debugLineNum = 127;BA.debugLine="item.Width = Width";
_item.Width = _width;
 //BA.debugLineNum = 128;BA.debugLine="item.Height = Height";
_item.Height = _height;
 //BA.debugLineNum = 129;BA.debugLine="Return item";
if (true) return _item;
 //BA.debugLineNum = 130;BA.debugLine="End Sub";
return null;
}
public static String  _drawface(main._item3d _item,float _centerx,float _centery,float _scale,float _rotationx) throws Exception{
double _cosrotation = 0;
int _intensity = 0;
int _highlightintensity = 0;
int _light = 0;
int _highlight = 0;
 //BA.debugLineNum = 166;BA.debugLine="Sub drawFace(item As item3D, CenterX As Float, CenterY As Float, scale As Float, RotationX As Float)";
 //BA.debugLineNum = 168;BA.debugLine="mCamera.save";
mostCurrent._mcamera.save();
 //BA.debugLineNum = 171;BA.debugLine="mCamera.translate(0, 0, CenterY)";
mostCurrent._mcamera.translate((float)(0),(float)(0),_centery);
 //BA.debugLineNum = 172;BA.debugLine="mCamera.rotateX(RotationX)";
mostCurrent._mcamera.rotateX(_rotationx);
 //BA.debugLineNum = 173;BA.debugLine="mCamera.translate(0, 0, -CenterY)";
mostCurrent._mcamera.translate((float)(0),(float)(0),(float)(-_centery));
 //BA.debugLineNum = 177;BA.debugLine="mCamera.getMatrix(mMatrix)";
mostCurrent._mcamera.GetMatrix(mostCurrent._mmatrix);
 //BA.debugLineNum = 178;BA.debugLine="mCamera.restore()";
mostCurrent._mcamera.restore();
 //BA.debugLineNum = 181;BA.debugLine="mMatrix.preTranslate(-CenterX, -CenterY)";
mostCurrent._mmatrix.preTranslate((float)(-_centerx),(float)(-_centery));
 //BA.debugLineNum = 182;BA.debugLine="mMatrix.postScale(scale, scale)";
mostCurrent._mmatrix.postScale(_scale,_scale);
 //BA.debugLineNum = 183;BA.debugLine="mMatrix.postTranslate(item.left + CenterX, item.top + CenterY)";
mostCurrent._mmatrix.postTranslate((float)(_item.Left+_centerx),(float)(_item.Top+_centery));
 //BA.debugLineNum = 186;BA.debugLine="Dim cosRotation As Double";
_cosrotation = 0;
 //BA.debugLineNum = 187;BA.debugLine="cosRotation = Cos(PI * RotationX / 180)";
_cosrotation = anywheresoftware.b4a.keywords.Common.Cos(_pi*_rotationx/(double)180);
 //BA.debugLineNum = 188;BA.debugLine="Dim intensity As Int";
_intensity = 0;
 //BA.debugLineNum = 189;BA.debugLine="intensity = AMBIENT_LIGHT + (DIFFUSE_LIGHT * cosRotation)";
_intensity = (int)(_ambient_light+(_diffuse_light*_cosrotation));
 //BA.debugLineNum = 190;BA.debugLine="Dim highlightIntensity As Int";
_highlightintensity = 0;
 //BA.debugLineNum = 191;BA.debugLine="highlightIntensity = (SPECULAR_LIGHT * Power(cosRotation,SHININESS))";
_highlightintensity = (int)((_specular_light*anywheresoftware.b4a.keywords.Common.Power(_cosrotation,_shininess)));
 //BA.debugLineNum = 192;BA.debugLine="If (intensity > MAX_INTENSITY) Then";
if ((_intensity>_max_intensity)) { 
 //BA.debugLineNum = 193;BA.debugLine="intensity = MAX_INTENSITY";
_intensity = _max_intensity;
 };
 //BA.debugLineNum = 195;BA.debugLine="If (highlightIntensity > MAX_INTENSITY) Then";
if ((_highlightintensity>_max_intensity)) { 
 //BA.debugLineNum = 196;BA.debugLine="highlightIntensity = MAX_INTENSITY";
_highlightintensity = _max_intensity;
 };
 //BA.debugLineNum = 198;BA.debugLine="Dim light As Int";
_light = 0;
 //BA.debugLineNum = 199;BA.debugLine="light = Colors.rgb(intensity, intensity, intensity)";
_light = anywheresoftware.b4a.keywords.Common.Colors.RGB(_intensity,_intensity,_intensity);
 //BA.debugLineNum = 200;BA.debugLine="Dim highlight As Int";
_highlight = 0;
 //BA.debugLineNum = 201;BA.debugLine="highlight = Colors.rgb(highlightIntensity, highlightIntensity, highlightIntensity)";
_highlight = anywheresoftware.b4a.keywords.Common.Colors.RGB(_highlightintensity,_highlightintensity,_highlightintensity);
 //BA.debugLineNum = 202;BA.debugLine="mPaint.SetLightingColorFilter(light, highlight)";
mostCurrent._mpaint.SetLightingColorFilter(_light,_highlight);
 //BA.debugLineNum = 205;BA.debugLine="ExDraw.drawBitmap4(MyCanvas, item.bmp,  mMatrix, mPaint)";
mostCurrent._exdraw.drawBitmap4(mostCurrent._mycanvas,(android.graphics.Bitmap)(_item.bmp.getObject()),mostCurrent._mmatrix,mostCurrent._mpaint);
 //BA.debugLineNum = 206;BA.debugLine="End Sub";
return "";
}
public static String  _drawitem(main._item3d _item) throws Exception{
float _centerx = 0f;
float _centery = 0f;
float _distfromcenter = 0f;
float _scale = 0f;
float _rotationx = 0f;
 //BA.debugLineNum = 132;BA.debugLine="Sub DrawItem(item As item3D)";
 //BA.debugLineNum = 133;BA.debugLine="Dim CenterX As Float";
_centerx = 0f;
 //BA.debugLineNum = 134;BA.debugLine="Dim CenterY As Float";
_centery = 0f;
 //BA.debugLineNum = 137;BA.debugLine="CenterX = item.Width / 2";
_centerx = (float)(_item.Width/(double)2);
 //BA.debugLineNum = 138;BA.debugLine="CenterY = item.Height / 2";
_centery = (float)(_item.Height/(double)2);
 //BA.debugLineNum = 141;BA.debugLine="Dim distFromCenter As Float";
_distfromcenter = 0f;
 //BA.debugLineNum = 142;BA.debugLine="distFromCenter = (item.Top + CenterY - HalfHeight) / HalfHeight";
_distfromcenter = (float)((_item.Top+_centery-_halfheight)/(double)_halfheight);
 //BA.debugLineNum = 143;BA.debugLine="Dim scale As Float";
_scale = 0f;
 //BA.debugLineNum = 144;BA.debugLine="scale = (1 - SCALE_DOWN_FACTOR * (1 - Cos(distFromCenter)))";
_scale = (float)((1-_scale_down_factor*(1-anywheresoftware.b4a.keywords.Common.Cos(_distfromcenter))));
 //BA.debugLineNum = 147;BA.debugLine="Dim RotationX As Float";
_rotationx = 0f;
 //BA.debugLineNum = 148;BA.debugLine="RotationX = CurrentRotation - 20 * distFromCenter";
_rotationx = (float)(_currentrotation-20*_distfromcenter);
 //BA.debugLineNum = 149;BA.debugLine="RotationX = RotationX Mod 90";
_rotationx = (float)(_rotationx%90);
 //BA.debugLineNum = 150;BA.debugLine="If (RotationX < 0) Then";
if ((_rotationx<0)) { 
 //BA.debugLineNum = 151;BA.debugLine="RotationX = RotationX + 90";
_rotationx = (float)(_rotationx+90);
 };
 //BA.debugLineNum = 156;BA.debugLine="If (RotationX < 45) Then";
if ((_rotationx<45)) { 
 //BA.debugLineNum = 157;BA.debugLine="drawFace(item, CenterX, CenterY, scale, RotationX - 90)";
_drawface(_item,_centerx,_centery,_scale,(float)(_rotationx-90));
 //BA.debugLineNum = 158;BA.debugLine="drawFace(item, CenterX, CenterY, scale, RotationX)";
_drawface(_item,_centerx,_centery,_scale,_rotationx);
 }else {
 //BA.debugLineNum = 161;BA.debugLine="drawFace(item, CenterX, CenterY, scale, RotationX)";
_drawface(_item,_centerx,_centery,_scale,_rotationx);
 //BA.debugLineNum = 162;BA.debugLine="drawFace(item, CenterX, CenterY, scale, RotationX - 90)";
_drawface(_item,_centerx,_centery,_scale,(float)(_rotationx-90));
 };
 //BA.debugLineNum = 164;BA.debugLine="End Sub";
return "";
}
public static String  _drawme() throws Exception{
int _i = 0;
 //BA.debugLineNum = 208;BA.debugLine="Sub DrawMe()";
 //BA.debugLineNum = 209;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 210;BA.debugLine="ExDraw.save2(MyCanvas, ExDraw.MATRIX_SAVE_FLAG)";
mostCurrent._exdraw.save2(mostCurrent._mycanvas,mostCurrent._exdraw.MATRIX_SAVE_FLAG);
 //BA.debugLineNum = 211;BA.debugLine="MyCanvas.DrawRect(ClearRect, Colors.Black, True, 1dip)";
mostCurrent._mycanvas.DrawRect((android.graphics.Rect)(mostCurrent._clearrect.getObject()),anywheresoftware.b4a.keywords.Common.Colors.Black,anywheresoftware.b4a.keywords.Common.True,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 //BA.debugLineNum = 213;BA.debugLine="For i = 0 To items.Size - 1";
{
final double step154 = 1;
final double limit154 = (int)(mostCurrent._items.getSize()-1);
for (_i = (int)(0); (step154 > 0 && _i <= limit154) || (step154 < 0 && _i >= limit154); _i += step154) {
 //BA.debugLineNum = 214;BA.debugLine="DrawItem(items.Get(i))";
_drawitem((main._item3d)(mostCurrent._items.Get(_i)));
 }
};
 //BA.debugLineNum = 216;BA.debugLine="ExDraw.restore(MyCanvas)";
mostCurrent._exdraw.restore(mostCurrent._mycanvas);
 //BA.debugLineNum = 218;BA.debugLine="Panel1.Invalidate";
mostCurrent._panel1.Invalidate();
 //BA.debugLineNum = 219;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 8;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 11;BA.debugLine="Dim items As List";
mostCurrent._items = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 12;BA.debugLine="Dim HalfHeight As Float";
_halfheight = 0f;
 //BA.debugLineNum = 14;BA.debugLine="Dim SCALE_DOWN_FACTOR As Float: SCALE_DOWN_FACTOR = 0.15";
_scale_down_factor = 0f;
 //BA.debugLineNum = 14;BA.debugLine="Dim SCALE_DOWN_FACTOR As Float: SCALE_DOWN_FACTOR = 0.15";
_scale_down_factor = (float)(0.15);
 //BA.debugLineNum = 15;BA.debugLine="Dim DEGREES_PER_SCREEN As Int: DEGREES_PER_SCREEN = 270";
_degrees_per_screen = 0;
 //BA.debugLineNum = 15;BA.debugLine="Dim DEGREES_PER_SCREEN As Int: DEGREES_PER_SCREEN = 270";
_degrees_per_screen = (int)(270);
 //BA.debugLineNum = 18;BA.debugLine="Dim AMBIENT_LIGHT As Int: AMBIENT_LIGHT = 55";
_ambient_light = 0;
 //BA.debugLineNum = 18;BA.debugLine="Dim AMBIENT_LIGHT As Int: AMBIENT_LIGHT = 55";
_ambient_light = (int)(55);
 //BA.debugLineNum = 20;BA.debugLine="Dim DIFFUSE_LIGHT As Int: DIFFUSE_LIGHT = 200";
_diffuse_light = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim DIFFUSE_LIGHT As Int: DIFFUSE_LIGHT = 200";
_diffuse_light = (int)(200);
 //BA.debugLineNum = 22;BA.debugLine="Dim SPECULAR_LIGHT As Float: SPECULAR_LIGHT = 70";
_specular_light = 0f;
 //BA.debugLineNum = 22;BA.debugLine="Dim SPECULAR_LIGHT As Float: SPECULAR_LIGHT = 70";
_specular_light = (float)(70);
 //BA.debugLineNum = 24;BA.debugLine="Dim SHININESS As Float: SHININESS = 200";
_shininess = 0f;
 //BA.debugLineNum = 24;BA.debugLine="Dim SHININESS As Float: SHININESS = 200";
_shininess = (float)(200);
 //BA.debugLineNum = 26;BA.debugLine="Dim MAX_INTENSITY As Int: MAX_INTENSITY = 0xFF";
_max_intensity = 0;
 //BA.debugLineNum = 26;BA.debugLine="Dim MAX_INTENSITY As Int: MAX_INTENSITY = 0xFF";
_max_intensity = (int)(0xff);
 //BA.debugLineNum = 28;BA.debugLine="Dim CurrentRotation As Int";
_currentrotation = 0;
 //BA.debugLineNum = 29;BA.debugLine="Dim CurrentTop As Int";
_currenttop = 0;
 //BA.debugLineNum = 30;BA.debugLine="Dim MyCanvas As Canvas";
mostCurrent._mycanvas = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Dim ScreenTop As Int: ScreenTop = 1";
_screentop = 0;
 //BA.debugLineNum = 32;BA.debugLine="Dim ScreenTop As Int: ScreenTop = 1";
_screentop = (int)(1);
 //BA.debugLineNum = 33;BA.debugLine="Dim Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Dim ExDraw As ABExtDrawing";
mostCurrent._exdraw = new com.AB.ABExtDrawing.ABExtDrawing();
 //BA.debugLineNum = 36;BA.debugLine="Dim mCamera As ABCamera";
mostCurrent._mcamera = new com.AB.ABExtDrawing.ABExtDrawing.ABCamera();
 //BA.debugLineNum = 37;BA.debugLine="Dim mMatrix As ABMatrix";
mostCurrent._mmatrix = new com.AB.ABExtDrawing.ABExtDrawing.ABMatrix();
 //BA.debugLineNum = 38;BA.debugLine="Dim mPaint As ABPaint";
mostCurrent._mpaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 40;BA.debugLine="Dim PI As Double: PI= 3.141592653589793238462643383279502884197";
_pi = 0;
 //BA.debugLineNum = 40;BA.debugLine="Dim PI As Double: PI= 3.141592653589793238462643383279502884197";
_pi = 3.141592653589793238462643383279502884197;
 //BA.debugLineNum = 42;BA.debugLine="Dim ClearRect As Rect";
mostCurrent._clearrect = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Dim CurrY As Int";
_curry = 0;
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
return "";
}
public static boolean  _panel1_touch(int _action,float _x,float _y) throws Exception{
int _deltay = 0;
int _i = 0;
main._item3d _it = null;
 //BA.debugLineNum = 221;BA.debugLine="Sub Panel1_Touch (Action As Int, X As Float, Y As Float) As Boolean 'Return True to consume the event";
 //BA.debugLineNum = 222;BA.debugLine="Dim DeltaY As Int";
_deltay = 0;
 //BA.debugLineNum = 223;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 //BA.debugLineNum = 225;BA.debugLine="CurrY = Y";
_curry = (int)(_y);
 break;
case 1:
 //BA.debugLineNum = 228;BA.debugLine="DeltaY = Y - CurrY";
_deltay = (int)(_y-_curry);
 //BA.debugLineNum = 229;BA.debugLine="CurrY = Y";
_curry = (int)(_y);
 //BA.debugLineNum = 230;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 231;BA.debugLine="Dim it As item3D";
_it = new main._item3d();
 //BA.debugLineNum = 232;BA.debugLine="For i = 0 To items.Size - 1";
{
final double step170 = 1;
final double limit170 = (int)(mostCurrent._items.getSize()-1);
for (_i = (int)(0); (step170 > 0 && _i <= limit170) || (step170 < 0 && _i >= limit170); _i += step170) {
 //BA.debugLineNum = 233;BA.debugLine="it = items.Get(i)";
_it = (main._item3d)(mostCurrent._items.Get(_i));
 //BA.debugLineNum = 234;BA.debugLine="it.Top = it.Top + DeltaY";
_it.Top = (int)(_it.Top+_deltay);
 //BA.debugLineNum = 235;BA.debugLine="items.Set(i, it)";
mostCurrent._items.Set(_i,(Object)(_it));
 }
};
 //BA.debugLineNum = 238;BA.debugLine="ScreenTop = ScreenTop + DeltaY";
_screentop = (int)(_screentop+_deltay);
 //BA.debugLineNum = 239;BA.debugLine="CurrentRotation = -(DEGREES_PER_SCREEN * ScreenTop) / Activity.Height";
_currentrotation = (int)(-(_degrees_per_screen*_screentop)/(double)mostCurrent._activity.getHeight());
 //BA.debugLineNum = 241;BA.debugLine="DrawMe";
_drawme();
 break;
case 2:
 break;
}
;
 //BA.debugLineNum = 246;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 248;BA.debugLine="End Sub";
return false;
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 5;BA.debugLine="Type item3D (bmp As Bitmap, Top As Int, Left As Int, Width As Int, Height As Int)";
;
 //BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
}
